# Creating Jira Flows from existing Use Cases

This repository shows how to create Jira issues of type "Flow" in the [SKAO Use Cases project][1]. Use Cases are the way we are specifying the high-level behaviours for SKAO Software, using the formalism of the [Use Cases 2.0 book][2].

## Code structure

Currently, the [code][3] is composed of a main function (after `if __name__ == '__main__'`), and many ancillary functions.

### Main Flow
When run, the code:

 1. asks for username and password to create a `jira_instace` that can be used both for querying and inserting issues
 2. uses a Jira Query Language (JQL) query to get use cases, and their embedded Basic and Alternate Flows; these flows are extracted using RegExes
 3. uses the compiled content from the Basic and Alternate flows to create Flow issue types which are linked to the relevant use case through its issue key.
  
### Compiling embedded Basic and Alternate Flows from Use Cases

The following JQL is used for the query:
```jql
project = USE and issuetype="Use Case" and cf[14702] = Solution and issueLinkType != includes
````

That JQL query avoids generating Flows for issues that have already linked Flows. Note that `cf[14702]`  stands for *Custom Field number 14702*, which in turn stands for the *Level* of the Use Case, being one of *Solution* or *Product*. In the future, the query could be changed to:

```jql
project = USE and issuetype="Use Case" and cf[14702] = Solution and ("Alternate Flows" is not EMPTY or "Basic Flow" is not EMPTY )
```

Which would look for Jira issues of issue type *Use Case* which still have embedded Basic or Alternative Flows.

Based on the result of the query, which is a Python list of issues, the Basic and Alternative Flows fields are extracted.

A new dictionary structure of the following form is created:

```python
{
    'USE-1': {
        'parent_title': 'Title/summary of USE-1'
        'basic': {
            'orig-key': 'USE-1',
            'steps': 'h3. Steps\n# Step 1\nStep 2',
            'trigger': 'The user behaviour that triggers USE-1',
        },
        'alternate': {
            1: {
                'orig-key': 'USE-1',
                'content': 'h3. Pre-Conditions\nTBW\n\nh3. Steps\n# Step 1\nStep 2h3. Post-Conditions\nTBW\n\n',
                'trigger': 'The user behaviour that triggers Alternate Flow 1 in USE-1',
            },
            2: {
                'orig-key': 'USE-1',
                'content': 'h3. Pre-Conditions\nTBW\n\nh3. Steps\n# Step 1\nStep 2h3. Post-Conditions\nTBW\n\n',
                'trigger': 'The user behaviour that triggers Alternate Flow 2 in USE-1',
            },
            
            .
            .
            .
            
            m: {
                'orig-key': 'USE-1',
                'content': 'h3. Pre-Conditions\nTBW\n\nh3. Steps\n# Step 1\nStep 2h3. Post-Conditions\nTBW\n\n',
                'trigger': 'The user behaviour that triggers Alternate Flow m in USE-1',
            }
        }
        
    },
    
    .
    .
    .
    
    'USE-n': {
        .
        .
        .
    }
}
```
#### Extracting Trigger and Steps from the Basic Flow
The Basic Flow is extracted using the following [regexp][4]:

```regex
(?umsi)(h3\. Steps).*?\n(\*|)Trigger(:|)(\*|)\s+(.*?)\n\s(.*)
```

 * The first part `(?umsi)` just indicates that the expression is intended for Unicode (`u`), multiline (`m`), with start-of-line markers (`s`), and case-insensitivity (`i`)
 * The second part uses several groups to capture different parts. But the last two groups capture the trigger, and the rest of the content of the flow is captured in the next group.
 
 For the Alternative Flows, another [multiline regex][5] is used:
 
 ```regex
 (?umsi)^h2\.\s+(.*?\n)(.*?(?:(?=(^h2\..*?\n|\Z))))
 ```

The first part `(?umsi)` is option setting, and is identical as in the expression above.

The second part is much more interesting, as it uses the `h2\` markers to delimit Alternative Flows.

The expression at the end `(?:(?=(^h2\..*?\n|\Z)))` helps do that:

 * `?:` is a non-capturing parenthesis, as we do not want to capture the boundary with the next item
 * `?=` is a look-ahead assertion: it matches _beyond_ the current expressions, to be able to set its limits
 * `\Z` represents the end of the string to be searched
 * `(x|y)` indicates a match with expression `x`, or expression `y`.
 * `(^h2\..*?\n|\Z)` then represents either another `h2.` heading at the beginning of the next line… or the end of the search string
 
Using `re.finditer`,  we get multiple matches for all flows, and we iterate through all of them, so we can add them to the dictionary.

### Generation of Flows from the Use Case dictionary

The dictionary generated by the previous steps is then used in this step to generate the Flows.

The key is understanding how issues are generated in Jira. Once we have an instantiated Jira object, which we keep passing around as `jira_instance`, you can create an issue symply by calling

```python
jira_instance.create_issue(fields=a_dict_of_fields)
```

For any jira issue, the minimum fields that need to be passed are:

 * The `project` field; in our case, `USE` for the Use Cases project.; or you could use the Use Case project ID instead, if you know it
 * The `summary` field, which is the title for the issue.
 * The `issuetype` field, which indicates the kind of issue being created; you can use either the `id` for it, or its name.
 
 In addition, for a _Flow_ kind of issue, you need to provide:
 
 * The *FlowTtype* (custom field 14810); *Alternate* or *Basic*.
 * The *Array Assembly* (custom field 12152): can contain any number of elements from `'ITF'`, `'AA0.5'`,`'AA1'`, `'AA2'`, `'AA3'`, `'AA4'`.
 * The *Is Included By* relationship(s) (custom field 14806): list of `{'key': key}` dictionaries to the parent Use Case(s) for the flow; for instance, `[{'key': 'USE-1'}]`.
 
 You are also recommended to provide, but it is not mandatory, the additional custom fields:
 
 * The Trigger (custom field 14812): The user action that triggers the Flow to be carried out.
 * The Constraints (custom field 14507): a string (can be Jira-formatted) with the Pre-, Post-, and Special Conditions that might affect the Flow.
 * The Flow Description (custom field 14811): a string (can be Jira-formatted) with the steps that are carried out when the flow is activated.
 
 
Please note that custom fields are specified in the Atlassian API as `customfield_fieldNumber` with `fieldNumber` specific to the field _and the instance_. Those fields are specified as `cf[fieldNumber]` in JQL queries.
 
 The `flow_fields_template` function is a factory function that creates the relevant fields in such a way that it can be used directly in the `fields` parameter to the `jira_instance.create_issue()` function.


[1]: https://jira.skatelescope.org/browse/USE "SKAO Jira: Use Cases project"
[2]: https://www.ivarjacobson.com/sites/default/files/field_iji_file/article/use-case_2_0_jan11.pdf "Ivar Jacobson: Use Case 2.0 (January 2011)"
[3]: insert-use-case-flows.py
[4]: https://regex101.com/r/fWMMZz/1
[5]: https://regex101.com/r/C166st/1